<template>
	<div id="vairus-vue-app">

		<!-- SPAWNS -->

		<transition name="fade">
			<div class="spawn" v-if="spawn.active" v-bind:style="getSpawnStyle" v-on:click="clickSpawn"></div>
		</transition>
		
		<transition name="fade">
			<div class="spawn" v-if="matrix.status == 'spawn'" v-bind:style="getMatrixStyle" v-on:click="openMatrixInfo"></div>
		</transition>
		
		<!-- VAIRUS CATCH -->
		
		<transition name="fade">
			<vairus-catch
				v-if="vairus_catch.vairus != null" 
				v-on:click.native="closeCatch"
				:vairus_catch="vairus_catch"
			/>
		</transition>
		
		<!-- TREASURE REWARDS -->
		
		<transition name="fade">
			<treasure-rewards
				v-if="treasure_rewards != null" 
				v-on:click.native="closeTreasure"
				:treasure="treasure_rewards"
			/>
		</transition>
		
		<!-- MANAGE VAULTS -->
		
		<transition name="fade">
			<vault-info	
				v-if="vault_info.active"
				:vault_data="vault_data"
				:vault_info="vault_info"
				@choosevairusforvault="chooseVairusForVault"
				@startvault="startVault"
				@closevaultinfo="closeVaultInfo"
			/>
		</transition>
		
		<!-- VAULT -->
		
		<transition name="fade">
			<vault  
				v-if="vault_data.active"
				:vault_data="vault_data"
				@stopvault="stopVault"
			/>
		</transition>
		
		<!-- VAULT REWARDS -->
		
		<transition name="fade">
			<vault-rewards
				v-if="vault_rewards.active"
				v-on:click.native="closeVaultRewards"
				:rewards="vault_rewards"
			/>
		</transition>
		
		<!-- MATRIX INFO -->
		
		<transition name="fade">
			<matrix-info
				v-if="matrix.status == 'info'"
				:matrix="matrix"
				@choosevairusformatrix="chooseVairusForMatrix"
				@closematrixinfo="closeMatrix"
				@matrixtutorial="openTutorial('matrix', 0, false);"
			/>
		</transition>
		
		
		<!-- CHOOSE VAIRUS -->

		<transition name="fade">
			<div class="vairus-list-container" v-if="vairus_list.active" v-on:click.self="closeList">
				<div class="inner">
					<div class="wrapper">
						<keep-alive>
							<vairus-list 
								ref="main_list"
								:list="vairus_list.list" 
								:boxes="boxes" 
								:main="false" 
								:stats="true" 
								@clicked="clickList"
								@mounted="listMounted"
							/>
						</keep-alive>
					</div>
					
					<transition name="fade">
						<div class="loader" v-if="vairus_list.loading">
							<div class="loading">
								<div class="dot"></div>
								<div class="dot"></div>
								<div class="dot"></div>
							</div>
						</div>
					</transition>
				</div>
			</div>
		</transition>
		
		
		<!-- NOTIFICATION -->
		
		<div class="vairus-messages">
			<transition-group name="message" tag="p">
				<div 
					class="vairus-message" 
					v-for="(notification, index) in notifications" 
					v-bind:key="notification.id"
					v-bind:style="{'bottom' : (index*40)+10+'px !important'}"
					v-on:click="removeNotification(index)"
				>
					{{getLocale(notification.message)}}
				</div>
			</transition-group>
		</div>
		
		<!-- TUTORIAL -->
		
		<transition name="fade">
			<div class="vairus-tutorial" v-if="tutorial.active">
				<div class="backdrop" v-on:click.self="closeTutorial"></div>
				
				<div class="content">
					<h2 class="hustle">Tutorial</h2>
					<h3>{{getLocale('tutorial_'+tutorial.step+'_title')}}</h3>
					<div class="text">{{getLocale('tutorial_'+tutorial.step+'_text')}}</div>
					
					<div 
						class="button" 
						v-if="tutorial.step == 'profile' || tutorial.step == 'network'" 
						v-on:click="(tutorial.step == 'network')? openProfile('network') : openProfile(null)"
					>Vai al profilo</div>
				</div>
			</div>
		</transition>
	</div>
</template>


<script>
	var browser = browser || chrome;
	import VairusList from '../components/VairusList.vue';
	import VairusCatch from '../components/VairusCatch.vue';
	import TreasureRewards from '../components/TreasureRewards.vue';
	import Vault from '../components/Vault.vue';
	import VaultInfo from '../components/VaultInfo.vue';
	import VaultRewards from '../components/VaultRewards.vue';
	import MatrixInfo from '../components/MatrixInfo.vue';
	import { commonMixin } from '../mixins/common.js';
	
	export default {
		props: ['options'],
		data: function () {
			return{
				notifications : [],
				notifications_index : 0,
				tutorial : {
					active : false,
					step : ''
				},
				screen : {
					width : 0,
					height : 0
				},
				spawn : {
					active : false,
					expiration : null,
					expiration_timeout : null,
					type : '',
					biome : null,
					unique_id : '',
					position : {
						left : 0, 
						top : 0
					}
				},
				vairus_catch : {
					vairus: null,
					shards: null,
					bytes: null
				},
				treasure_rewards : null,
				vault_info : {
					active : false,
					vairus : null
				},
				vault_data : {
					active : false,
					difficulty : 0,
					avaiable_stats : [],
					rotating : false,
					rotation : 0
				},
				vault_rewards : {
					active : false,
					rewards : ''
				},
				vairus_list : {
					active : false,
					loading : false,
					list : [],
					reason : ''
				},
				matrix : {
					status : false,
					level : null,
					selected_vairus : null,
					assigned_vairus : null,
					expiration : 0
				},
				boxes : [],
			}
		},
		created() {
			window.addEventListener('resize', this.updateSize);
			window.addEventListener('orientationchange', this.updateSize);
			this.updateSize();
			
			document.addEventListener("visibilitychange", function(){
				if(document.visibilityState == 'visible'){
					this.checkVairusExpiration();
				} 
			}.bind(this));
			/* SERVER REQUEST */

			browser.runtime.sendMessage({
				type : 'navigate_url',
				data : { url : location.href }
			});
			
			browser.runtime.onMessage.addListener( function(request, sender, sendResponse) {
				switch(request.type){
					case 'spawn':
						//Messaggio di comparsa spawn
						this.addNotification(request.data.type+'_spawn');
						
						this.spawn.position.left = (Math.random()*0.9)+0.05;
						this.spawn.position.top = (Math.random()*0.9)+0.05;
						
						this.spawn.active = true;
						this.spawn.type = request.data.type;
						this.spawn.unique_id = request.data.unique_id;
						this.spawn.biome = request.data.biome;
						
						var dt = new Date();
						dt.setSeconds( dt.getSeconds() + 600 );
						this.spawn.expiration = dt.getTime();
						
						this.spawn.expiration_timeout = setTimeout(this.checkVairusExpiration, 600*1000);
						
						//Tutorial
						if(request.data.tutorial.flags.charAt(0) == '0'){
							this.openTutorial('start', 0, true);
						}
					break;
					case 'click_spawn_result':
						//Messaggio di risultato di click dello spawn
						switch(request.data.type){
							case 'vairus' : 
								if(request.success){
								
									if(!this.checkOption('hide_vairus_popup')){
										this.vairus_catch.vairus = request.data.vairus;
										this.vairus_catch.bytes = request.data.bytes;
										this.vairus_catch.shards = request.data.shards;
									}
									
									//Tutorial
									if(request.data.tutorial){
										this.openTutorial(request.data.tutorial, (request.data.tutorial == 'profile')? 1 : 2, true);
									}
								}else{
									this.addNotification('catch_failed');
								}
							break;
							case 'treasure' :
								if(request.success){
									this.treasure_rewards = request.data;
								}else{
									this.addNotification('treasure_failed');
								}
							break;
							case 'vault' : 
								this.vault_info.active = true;
							break;
						}
					break;
					case 'spawn_matrix':
						if(request.data.current_vairus == null || !this.checkOption('hide_completed_matrix')){
							this.addNotification('matrix_spawn');
							this.matrix.status = 'spawn';
							this.matrix.level = request.data.level;
							this.matrix.expiration = request.data.expiration;
							this.matrix.assigned_vairus = request.data.vairus;
							this.matrix.current_score = request.data.current_score;
							this.matrix.current_vairus = request.data.current_vairus;
							this.matrix.score_boost = request.data.score_boost;
							this.matrix.main_stat = request.data.main_stat;
							this.matrix.secondary_stat = request.data.secondary_stat;
							this.matrix.tutorial = request.data.tutorial;
						}
					break;
				}
				
			}.bind(this));
		},
		methods: {
			checkOption(option){
				if(!this.options.hasOwnProperty(option)) return false;
				
				return this.options[option];
			},
			updateSize(){
				this.screen.width = Math.max(document.body.scrollWidth, window.innerWidth);
				this.screen.height = Math.max(document.body.scrollHeight, window.innerHeight);
			},
			closeCatch(){
				this.vairus_catch.vairus = null;
			},
			closeTreasure(){
				this.treasure_rewards = null;
			},
			addNotification(message){
				if(!this.checkOption('hide_notification')){
					var id = this.notifications_index;
					
					this.notifications.push({
						message:message,
						id : id
					});
					
					setTimeout(function(){
						this.removeNotification(0)
					}.bind(this), 5000);
					
					this.notifications_index = id+1;
				}
			},
			removeNotification(index){
				this.notifications.splice(index, 1);
			},
			openTutorial(step, index, update){
				this.tutorial.active = true;
				this.tutorial.step = step;
				
				if(update){
					browser.runtime.sendMessage({
						type : 'tutorial_flag',
						data : { 
							flag : step,
							index : index
						}
					});
				}
			},
			closeTutorial(){
				this.tutorial.active = false;
			},
			openProfile(hash){
				let url = '/profile/profile.html';
				if(hash != null) url+= '#'+hash;
				window.open(browser.extension.getURL(url) , '_blank');
			},
			checkVairusExpiration(){
				if(this.spawn.expiration != null){
					var time_left = this.spawn.expiration - new Date().getTime();
				
					if(time_left <= 0){
						this.spawn.active = false;
						this.spawn.expiration = null;
					}else{
						clearTimeout(this.spawn.expiration_timeout);
						this.spawn.expiration_timeout = setTimeout(this.checkVairusExpiration, time_left);
					}
				}
			},
			clickSpawn(){
				this.spawn.active = false;
				
				browser.runtime.sendMessage({
					type : 'spawn_click',
					data : { unique_id : this.spawn.unique_id}
				});
			},
			closeVaultInfo(){
				this.vault_info.active = false;
			},
			chooseVairusForVault(){
				this.vairus_list.reason = 'vault'
				this.requestList();
			},
			startVault(){
				browser.runtime.sendMessage({
					type : 'start_vault',
					data : {
						unique_id : this.spawn.unique_id,
						vairus_id : this.vault_info.vairus.unique_id
					}
				}, function(response){
					this.closeVaultInfo();
						
					if(response.start){
						this.vault_data.active = true;
						this.vault_data.unique_id = this.spawn.unique_id;
						this.vault_data.defences = response.defences;
						this.vault_data.current_stats = response.stats_value;
					}else{
						this.addNotification('vault_decay');
					}
				}.bind(this));
			},
			stopVault(rewards){
				this.vault_data.active = false;
				this.openVaultRewards(rewards);
			},
			openVaultRewards(rewards){
				this.vault_rewards.active = true;
				this.vault_rewards.rewards = rewards;
			},
			closeVaultRewards(){
				this.vault_rewards.active = false;
			},
			openMatrixInfo(){
				this.matrix.status = 'info';
				
				//Tutorial
				if(this.matrix.tutorial){
					this.matrix.tutorial = false;
					
					setTimeout(function(){
						this.openTutorial('matrix', 3, true);
					}.bind(this), 500)
				}
			},
			closeMatrix(){
				this.matrix.status = false;
			},
			chooseVairusForMatrix(){
				this.vairus_list.reason = 'matrix'
				this.requestList();
			},
			requestList(){
				this.vairus_list.active = true;
				this.vairus_list.loading = true;
				
				if(this.vairus_list.list.length == 0){
					browser.runtime.sendMessage({
						type : 'request_list',
						data : {}
					}, function(response){
						this.vairus_list.list = response.vairus_list;
						this.boxes = [{"name":browser.i18n.getMessage('base_box'),"vairus":[]}].concat(response.boxes);
					}.bind(this));
				}
			},
			clickList(unique_id){
				switch(this.vairus_list.reason){
					case 'vault':
						var vairus = this.vairus_list.list.find(function(v){ return v.unique_id == unique_id; })
						this.vault_info.vairus = vairus;
					break;
					case 'matrix':
						var vairus = this.vairus_list.list.find(function(v){ return v.unique_id == unique_id; })
						this.matrix.selected_vairus = vairus;
					break;
				}
				
				this.closeList();
			},
			closeList(){
				this.vairus_list.active = false;
			},
			listMounted(){
				this.vairus_list.loading = false;
			}
		},
		computed: {
			getSpawnStyle(){
				if(this.spawn.type == 'vairus'){
					var background = 'url('+browser.runtime.getURL('/images/eggs/'+this.spawn.biome+'.svg')+') !important';
				}else{
					var background = 'url('+browser.runtime.getURL('/images/'+this.spawn.type+'.png')+') !important';
				}
			
				return {
					'left': (this.screen.width*this.spawn.position.left)+'px !important',
					'top': (this.screen.height*this.spawn.position.top)+'px !important',
					'background-image': background
				}
			},
			getMatrixStyle(){
				return {
					'left': ((this.screen.width*0.5)-20)+'px !important',
					'top': ((this.screen.height*0.5)-20)+'px !important',
					'background-image': 'url('+browser.runtime.getURL('/images/matrix.png')+') !important'
				}
			},
		},
		mixins: [commonMixin],
		components: {
			VairusList,
			VairusCatch,
			TreasureRewards,
			Vault,
			VaultInfo,
			VaultRewards,
			MatrixInfo
		}
	}
</script>


<style lang="scss">

	.bold{
		font-weight: bold;
	}
	.uppercase{
		text-transform: uppercase;
	}
	.align-center{
		text-align: center;
	}
	.align-right{
		text-align: right;
	}
	.small-font{
		font-size: 12px;
	}
	.medium-font{
		font-size: 18px;
	}
	h4, .medium-large-font, .has-medium-font-size{
		font-size: 22.5px;
	}
	h3, .large-font{
		font-size: 30px;
	}
	h2, .very-large-font{
		font-size: 48.75px;
	}
	h1, .title-font{
		font-size: 56.25px;
	}
	.button{
		display: inline-block;
		padding: 5px 20px;
		border-radius: 15px;
		background-color: white;
		color: black;
		text-transform: uppercase;
		text-align: center;
		font-weight: bold;
		cursor: pointer;
		line-height: 22px;
	}
	.button.outline{
		background-color: black;
		border: 1px solid white;
	}
	.button.disabled{
		opacity: 0.4;
		cursor: default;
		pointer-events: none;
	}

	#vairus-vue-app{
		font-family: Barlow;
		font-size: 15px;
	}
	#vairus-vue-app .hustle{
		font-family: The Hustle;
		font-size: 50px;
		line-height: 1;
	}
	#vairus-vue-app .flex{
		display: flex;
	}
	#vairus-vue-app .flex.space{
		justify-content: space-between;
	}
	#vairus-vue-app .bold{
		font-weight: bold;
	}
	#vairus-vue-app .spawn{
		position: absolute;
		width: 60px;
		height: 60px;
		cursor: pointer;
		z-index: 2147483647;
		animation: shake 2s cubic-bezier(.36,.07,.19,.97) infinite;
		background-size: cover;
	}
	#vairus-vue-app .vairus-messages{
		position: fixed;
		bottom: 10px;
		right: 0;
		z-index: 2147483647;
	}
	#vairus-vue-app .vairus-message{
		position: absolute;
		bottom: 0;
		right: 0;
		line-height: 18px;
		padding: 5px;
		margin-right: 20px;
		background-color: white;
		border: 2px solid black;
		border-radius: 10px;
		white-space: nowrap;
		transition: bottom 0.2s cubic-bezier(.47,1.64,.41,.8);
		cursor: pointer;
		color: black;
	}
	#vairus-vue-app .vairus-list-container{
		position: fixed;
		top: 0;
		left: 0;
		width: 100%;
		height: 100%;
		z-index: 2147483647;
	}
	#vairus-vue-app .vairus-list-container .inner{
		position: absolute;
		top: 5%;
		left: 5%;
		width: 90%;
		height: 90%;
		overflow-y: auto;
		background-color: black;
		border: 1px solid white;
		color: white;
	}
	#vairus-vue-app .vairus-list-container .inner > .wrapper{
		padding: 50px 2.5% 0;
	}

	.vairus-tutorial{
		position: fixed;
		left: 0;
		top: 0;
		height: 100%;
		width: 100%;
		z-index: 2147483647;
		
		.backdrop{
			position: absolute;
			left: 0;
			top: 0;
			height: 100%;
			width: 100%;
			background-color: rgba(0, 0, 0, 0.7);
		}
		
		.content{
			position: absolute;
			left: 50%;
			top: 50%;
			transform: translate(-50%, -50%);
			padding: 25px;
			border: 1px solid gray;
			background-color: #38383D;
			z-index: 5;
			color: white;
			
			h2{
				margin: 0;
			}
			h3{
				margin: 10px 0;
			}
			.text{
				white-space: pre-wrap;
			}
			.button{
				margin-top: 20px;
			}
		}
	}



	/* ANIMATION */


	@keyframes shake {
	  0% { transform: translate(0.5px, 0.5px) rotate(0deg); }
	  3% { transform: translate(-0.5px, -1px) rotate(-5deg); }
	  6% { transform: translate(-1px, 0px) rotate(5deg); }
	  9% { transform: translate(1px, 1px) rotate(0deg); }
	  12% { transform: translate(0.5px, -0.5px) rotate(5deg); }
	  15% { transform: translate(-0.5px, 1px) rotate(-5deg); }
	  18% { transform: translate(-1px, 0.5px) rotate(0deg); }
	  24% { transform: translate(1px, 0.5px) rotate(-5deg); }
	  27% { transform: translate(-0.5px, -0.5px) rotate(5deg); }
	  30% { transform: translate(0.5px, 1px) rotate(0deg); }
	  33% { transform: translate(0.5px, -1px) rotate(-5deg); }
	  36% { transform: translate(0) rotate(0); }
	}

	/* VUE TRANSITION */

	#vairus-vue-app .message-enter-active,
	#vairus-vue-app .message-leave-active {
		transition: all 0.2s;
	}
	#vairus-vue-app .message-enter{
		right: -200px;
	}
	#vairus-vue-app .message-leave-to{
	  opacity: 0;
	}

	#vairus-vue-app .fade-enter-active, 
	#vairus-vue-app .fade-leave-active {
		transition: opacity 0.2s;
	}
	#vairus-vue-app .fade-enter, #vairus-vue-app .fade-leave-to{
		opacity: 0;
	}
</style>